:- module(addTreeCFG,[]).

translate((L --> R),(Ltr --> (Rtr,{Code}))) :-
   (atom(L) -> translate1(L,Ltr,Baum)
   ; format(user,'addTreeCFG:translate/2 kann nur Atome
            um ein Baumargument erweitern, nicht ~w.\n',L),
       fail),     % wegen =.. [L|_]
   translate2(R,Rtr,Baumliste),  
   Code = (Baum =.. [L|Baumliste]).
% translate1(+Kategorie,-Term,?Baum)

translate1(Kategorie,Term,Baum) :-
    Kategorie =.. [Funktor|Argumente],
    append(Argumente,[Baum],MehrArgumente),
    Term =.. [Funktor|MehrArgumente].

% translate2(+Cat,-CatTr,-Bume)

translate2((A,B),((Atr,Btr),{Code}),Baeume) :-
    !, translate2(A,Atr,BaeumeA),
       translate2(B,Btr,BaeumeB),
    Code = append(BaeumeA,BaeumeB,Baeume).

translate2((A;B),(Atr;Btr),Baeume) :-
    !, translate2(A,Atr0,BaeumeA),
       translate2(B,Btr0,BaeumeB),
    Atr = (Atr0,{ Baeume=BaeumeA }),
    Btr = (Btr0,{ Baeume=BaeumeB }).

translate2([Atom],[Atom],[Atom]) :- !.

translate2({Prolog},{Prolog},[]) :- !.

translate2(Cat,CatTr,[Baum]) :-
    !, translate1(Cat,CatTr,Baum).

