:- module(stammformenlexikon,[lex/4]).

% lex(?Stammform,?Wortart,?Artmerkmale,?Flexionsklasse)

lex(entdecken,      v,[nom,akk],rg(0)).
lex(umkreisen,      v,[nom,akk],rg(0)).

lex('Astronom',     n,[mask], (s2e,p3e)).
lex('Durchmesser', rn,[mask], (s1, p2 )).
lex('Himmelskrper',n,[mask], (s1, p2 )).
lex('Mond',        rn,[mask], (s1e,p1 )).
lex('Planet',      rn,[mask], (s2e,p3e)).
lex('Sonne',        n,[fem],  (s3, p3 )).

lex('Galilei',     en,[mask],(s1,-)).
lex('Kepler',      en,[mask],(s1,-)).
lex('Triton',      en,[mask],(s1,-)).
lex('Uranus',      en,[mask],(s1,-)).
lex('Venus',       en,[fem], (s3,-)).

