:- use_module(['wortformen.pl','vollformenlexikon.pl']).

% Verbflexion bei einem Vollformenlexikon:
% verbflexion_vlex(+Stammform,+Formmerkmale,-Vollform)

verbflexion_vlex(Stammform,Formmerkmale,Vollform) :-
    wort(Stammform,Formmerkmale,Vollform).

% Flexionsprogramm: verbflexion_vlex(Stammform+)

verbflexion_vlex(Stammform) :-   % Stammform = Infinitiv
    form(vfin,Formmerkmale),     % moegl.Merkmale holen
    wort(Stammform,Formmerkmale,Vollform),
    write(Formmerkmale),write(': '),write(Vollform),nl,
    fail.                        % weitere Loesungen?
verbflexion_vlex(_).             % fertig.

